
(DEFINE (DOMAIN LOGISTICS)
 (:REQUIREMENTS :STRIPS :TYPING)
 (:TYPES
   CITY PHYSOBJ PLACE - OBJECT
   PACKAGE VEHICLE - PHYSOBJ
   AIRPORT LOCATION - PLACE
   AIRPLANE TRUCK - VEHICLE)
 (:PREDICATES (IN-CITY ?LOC - PLACE ?CITY - CITY)
  (AT ?OBJ - PHYSOBJ ?LOC - PLACE) (IN ?PKG - PACKAGE ?VEH - VEHICLE))
 (:ACTION FLY-AIRPLANE :PARAMETERS
  (?LOC-TO - AIRPORT ?LOC-FROM - AIRPORT ?AIRPLANE - AIRPLANE)
  :PRECONDITION (AT ?AIRPLANE ?LOC-FROM) :EFFECT
  (AND
    (NOT (AT ?AIRPLANE ?LOC-FROM))
    (AT ?AIRPLANE ?LOC-TO)))
 (:ACTION DRIVE-TRUCK :PARAMETERS
  (?LOC-FROM - PLACE ?CITY - CITY ?LOC-TO - PLACE ?TRUCK - TRUCK)
  :PRECONDITION
  (AND
    (AT ?TRUCK ?LOC-FROM)
    (IN-CITY ?LOC-FROM ?CITY)
    (IN-CITY ?LOC-TO ?CITY))
  :EFFECT
  (AND
    (NOT (AT ?TRUCK ?LOC-FROM))
    (AT ?TRUCK ?LOC-TO)))
 (:ACTION UNLOAD-AIRPLANE :PARAMETERS
  (?AIRPLANE - AIRPLANE ?PKG - PACKAGE ?LOC - PLACE) :PRECONDITION
  (AND
    (IN ?PKG ?AIRPLANE)
    (AT ?AIRPLANE ?LOC))
  :EFFECT
  (AND
    (NOT (IN ?PKG ?AIRPLANE))
    (AT ?PKG ?LOC)))
 (:ACTION UNLOAD-TRUCK :PARAMETERS
  (?PKG - PACKAGE ?TRUCK - TRUCK ?LOC - PLACE) :PRECONDITION
  (AND
    (AT ?TRUCK ?LOC)
    (IN ?PKG ?TRUCK))
  :EFFECT
  (AND
    (NOT (IN ?PKG ?TRUCK))
    (AT ?PKG ?LOC)))
 (:ACTION LOAD-AIRPLANE :PARAMETERS
  (?AIRPLANE - AIRPLANE ?LOC - PLACE ?PKG - PACKAGE) :PRECONDITION
  (AND
    (AT ?PKG ?LOC)
    (AT ?AIRPLANE ?LOC))
  :EFFECT
  (AND
    (NOT (AT ?PKG ?LOC))
    (IN ?PKG ?AIRPLANE)))
 (:ACTION LOAD-TRUCK :PARAMETERS
  (?LOC - PLACE ?TRUCK - TRUCK ?PKG - PACKAGE) :PRECONDITION
  (AND
    (AT ?TRUCK ?LOC)
    (AT ?PKG ?LOC))
  :EFFECT
  (AND
    (NOT (AT ?PKG ?LOC))
    (IN ?PKG ?TRUCK))))